diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/test.h ns-3.36/src/core/model/test.h
--- ns-3.35/src/core/model/test.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/test.h	2022-04-30 18:23:57.798733200 -0700
@@ -1037,19 +836,30 @@
           ReportTestFailure (std::string (#actual) + " (actual) > " +   \
                              std::string (#limit) + " (limit)",         \
                              actualStream.str (), limitStream.str (),   \
-                             msgStream.str (), file, line);             \
+                             msgStream.str (), __FILE__, __LINE__);     \
+          CONTINUE_ON_FAILURE;                                          \
         }                                                               \
     } while (false)
 
 /**
- * \ingroup testingimpl
- * \brief Test that an actual value is greater than or equal to limit
- * and report if not.
+ * \ingroup testing
+ *
+ * \brief Test that an actual value is greater than or equal to a
+ * limit and report and abort if not.
  *
- * Required to avoid use of return statement which allows use in
- * methods (callbacks) returning void.
+ * Check to see if the actual value found in a test case is greater
+ * than or equal to the limit value.  If the actual value is greater
+ * nothing happens, but if the check fails, an error is reported in a
+ * consistent way and the execution of the current test case is
+ * aborted.
+ *
+ * The message is interpreted as a stream.
+ *
+ * \param [in] actual Expression for the actual value found during the test.
+ * \param [in] limit Expression for the limit value of the test.
+ * \param [in] msg Message that is output if the test does not pass.
  */
-#define NS_TEST_EXPECT_MSG_GT_OR_EQ_INTERNAL(actual, limit, msg, file, line)  \
+#define NS_TEST_ASSERT_MSG_GT_OR_EQ(actual, limit, msg)                 \
   do {                                                                  \
       if (!((actual) >= (limit)))                                       \
         {                                                               \
@@ -1063,7 +873,8 @@
           ReportTestFailure (std::string (#actual) + " (actual) > " +   \
                              std::string (#limit) + " (limit)",         \
                              actualStream.str (), limitStream.str (),   \
-                             msgStream.str (), file, line);             \
+                             msgStream.str (), __FILE__, __LINE__);     \
+          CONTINUE_ON_FAILURE;                                          \
         }                                                               \
     } while (false)
 
@@ -1085,8 +896,23 @@
  * \param [in] limit Expression for the limit value of the test.
  * \param [in] msg Message that is output if the test does not pass.
  */
-#define NS_TEST_EXPECT_MSG_GT(actual, limit, msg) \
-  NS_TEST_EXPECT_MSG_GT_INTERNAL (actual, limit, msg, __FILE__, __LINE__)
+#define NS_TEST_EXPECT_MSG_GT(actual, limit, msg)                       \
+  do {                                                                  \
+      if (!((actual) > (limit)))                                        \
+        {                                                               \
+          ASSERT_ON_FAILURE;                                            \
+          std::ostringstream msgStream;                                 \
+          msgStream << msg;                                             \
+          std::ostringstream actualStream;                              \
+          actualStream << actual;                                       \
+          std::ostringstream limitStream;                               \
+          limitStream << limit;                                         \
+          ReportTestFailure (std::string (#actual) + " (actual) > " +   \
+                             std::string (#limit) + " (limit)",         \
+                             actualStream.str (), limitStream.str (),   \
+                             msgStream.str (), __FILE__, __LINE__);     \
+        }                                                               \
+    } while (false)
 
 /**
  * \ingroup testing
@@ -1106,9 +932,23 @@
  * \param [in] limit Expression for the limit value of the test.
  * \param [in] msg Message that is output if the test does not pass.
  */
-#define NS_TEST_EXPECT_MSG_GT_OR_EQ(actual, limit, msg) \
-  NS_TEST_EXPECT_MSG_GT_OR_EQ_INTERNAL (actual, limit, msg, __FILE__, __LINE__)
-
+#define NS_TEST_EXPECT_MSG_GT_OR_EQ(actual, limit, msg)                 \
+  do {                                                                  \
+      if (!((actual) >= (limit)))                                       \
+        {                                                               \
+          ASSERT_ON_FAILURE;                                            \
+          std::ostringstream msgStream;                                 \
+          msgStream << msg;                                             \
+          std::ostringstream actualStream;                              \
+          actualStream << actual;                                       \
+          std::ostringstream limitStream;                               \
+          limitStream << limit;                                         \
+          ReportTestFailure (std::string (#actual) + " (actual) > " +   \
+                             std::string (#limit) + " (limit)",         \
+                             actualStream.str (), limitStream.str (),   \
+                             msgStream.str (), __FILE__, __LINE__);     \
+        }                                                               \
+    } while (false)
 
 /**
  * \ingroup testing
@@ -1150,7 +990,7 @@
  *
  * \see sample-test-suite.cc
  */
-class TestCase : private NonCopyable
+class TestCase
 {
 public:
   /** \brief How long the test takes to execute. */
@@ -1166,6 +1006,10 @@
    */
   virtual ~TestCase ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  TestCase (const TestCase &) = delete;
+  TestCase & operator = (const TestCase &) = delete;
+
   /**
    * \return The name of this test
    */
@@ -1202,7 +1046,7 @@
    * subdirectories, then the variable NS_TEST_SOURCEDIR may not work
    * and the user may want to explicitly pass in a directory string.
    *
-   * Note that NS_TEST_SOURCEDIR is set in src/wscript for each module
+   * Note that NS_TEST_SOURCEDIR is set in src/CMakeLists.txt for each module
    */
   void SetDataDir (std::string directory);
 
@@ -1403,7 +1247,7 @@
  * \brief A simple way to store test vectors (for stimulus or from responses)
  */
 template <typename T>
-class TestVectors : private NonCopyable
+class TestVectors
 {
 public:
   /**
@@ -1415,6 +1259,10 @@
    */
   virtual ~TestVectors ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  TestVectors (const TestVectors &) = delete;
+  TestVectors & operator = (const TestVectors &) = delete;
+
   /**
    * \brief Set the expected length of this vector.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/time.cc ns-3.36/src/core/model/time.cc
--- ns-3.35/src/core/model/time.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/time.cc	2022-04-30 18:23:57.798733200 -0700
@@ -61,7 +61,10 @@
     return UNIT_COEFF[u] * std::pow (10L, UNIT_POWER[u]); 
   }
 
-  /** Initializer for \c UNIT_VALUE */
+  /** 
+   * Initializer for \c UNIT_VALUE 
+   * \returns The array of scale factors between units.
+   */
   long double *
   InitUnitValue (void)
   {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/traced-value.h ns-3.36/src/core/model/traced-value.h
--- ns-3.35/src/core/model/traced-value.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/traced-value.h	2022-04-30 18:23:57.802733200 -0700
@@ -75,7 +75,7 @@
  */
 /**
  *  TracedValue Callback signature for POD.
- *
+ * @{
  * \param [in] oldValue original value of the traced variable
  * \param [in] newValue new value of the traced variable
  */
@@ -89,8 +89,11 @@
 typedef void (* Int64) (int64_t  oldValue, int64_t  newValue);
 typedef void (* Uint64)(uint64_t oldValue, uint64_t newValue);
 typedef void (* Double)(double   oldValue, double   newValue);
+/**@}*/
+/** TracedValue Callback signature for void. */
 typedef void (* Void)  (void);
 /**@}*/
+
 }  // namespace TracedValueCallback
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/tuple.h ns-3.36/src/core/model/tuple.h
--- ns-3.35/src/core/model/tuple.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/core/model/tuple.h	2022-04-30 18:23:57.802733200 -0700
@@ -0,0 +1,534 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef TUPLE_H
+#define TUPLE_H
+
+#include <ns3/attribute-helper.h>
+#include <ns3/string.h>
+
+#include <sstream>
+#include <type_traits>
+#include <utility>
+#include <tuple>
+#include <algorithm>
+
+namespace ns3 {
+
+/**
+ * \brief Stream insertion operator.
+ * See https://en.cppreference.com/w/cpp/utility/apply
+ *
+ * Prints tuple values separated by a comma. E.g., if the tuple contains
+ * v1, v2 and v3, then "v1, v2, v3" will be added to the stream.
+ *
+ * \tparam Args \deduced Tuple arguments
+ * \param os the output stream
+ * \param t the tuple
+ * \returns a reference to the stream
+ */
+template <class... Args>
+std::ostream &
+operator << (std::ostream &os, const std::tuple<Args...> &t)
+{
+  std::apply ([&os](auto&&... args)
+              {
+                std::size_t n{0};
+                ((os << args << (++n != sizeof...(Args) ? ", " : "")), ...);
+              },
+              t);
+  return os;
+}
+
+
+// Doxygen for this class is auto-generated by
+// utils/print-introspected-doxygen.h
+
+/**
+ * Hold objects of type std::tuple<Args...>.
+ * \tparam Args \explicit The list of AttributeValues to be held by this TupleValue
+ */
+template <class... Args>
+class TupleValue : public AttributeValue
+{
+public:
+  /** Type of value stored in the TupleValue. */
+  typedef std::tuple<Args...> value_type;
+  /** Type returned by Get or passed in Set. */
+  typedef std::tuple<std::invoke_result_t<decltype(&Args::Get),Args>...> result_type;
+
+  TupleValue ();
+
+  /**
+   * Construct this TupleValue from a std::tuple
+   *
+   * \param [in] value Value with which to construct.
+   */
+  TupleValue (const result_type &value);
+
+  Ptr<AttributeValue> Copy (void) const override;
+  bool DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker) override;
+  std::string SerializeToString (Ptr<const AttributeChecker> checker) const override;
+
+  /**
+   * Get the stored values as a std::tuple.
+   * 
+   * This differs from the actual value stored in the object which is 
+   * a tuple of Ptr<AV> where AV is a class derived from AttributeValue.
+   * \return stored values as a std::tuple
+   */
+  result_type Get (void) const;
+  /**
+   * Set the stored values.
+   */
+  void Set (const result_type &value);
+
+  /**
+   * Get the attribute values as a tuple.
+   * \return the attribute values as a tuple
+   */
+  value_type GetValue (void) const;
+
+  /**
+   * Set the given variable to the values stored by this TupleValue object.
+   *
+   * \tparam T \deduced the type of the given variable (normally, the argument type
+   *           of a set method or the type of a data member)
+   * \return true if the given variable was set
+   */
+  template <typename T>
+  bool GetAccessor (T &value) const;
+
+private:
+  /**
+   * Set the attribute values starting from the given values.
+   * Used by DeserializeFromString method.
+   *
+   * \tparam Is \deduced index sequence
+   * \param values the given attribute values
+   * \return true if the attribute values of this object were set
+   */
+  template <std::size_t... Is>
+  bool SetValueImpl (std::index_sequence<Is...>, const std::vector<Ptr<AttributeValue>>& values);
+
+  value_type m_value;   //!< Tuple of attribute values
+};
+
+/**
+ * Create a TupleValue object. Enable to write code like this snippet:
+ *
+ * \code
+ * typedef std::tuple<uint16_t, double> Tuple;
+ * typedef std::tuple<UintegerValue, DoubleValue> Pack;
+ *
+ * TupleValue<UintegerValue, DoubleValue> t = MakeTupleValue<Pack> (Tuple {10, 1.5});
+ * \endcode
+ *
+ * \tparam T1 \explicit A std::tuple of the AttributeValue types included in TupleValue
+ * \tparam T2 \deduced A std::tuple of the type of elements stored by TupleValue
+ * \param t the tuple of elements stored by TupleValue
+ * \return a TupleValue object
+ */
+template <class T1, class T2>
+auto MakeTupleValue (T2 t);
+
+
+/**
+ * Checker for attribute values storing tuples.
+ */
+class TupleChecker : public AttributeChecker
+{
+public:
+  /**
+   * Get the checkers for all tuple elements.
+   *
+   * \return the checkers for all tuple elements
+   */
+  virtual const std::vector<Ptr<const AttributeChecker>>& GetCheckers (void) const = 0;
+};
+
+
+/**
+ * Create a TupleChecker from AttributeCheckers associated with TupleValue elements.
+ * 
+ * \tparam Args \explicit Attribute value types
+ * \tparam Ts \deduced Attribute checker types
+ * \param checkers attribute checkers
+ * \return Pointer to TupleChecker instance.
+ */
+template <class... Args, class... Ts>
+Ptr<const AttributeChecker> MakeTupleChecker (Ts... checkers);
+
+
+/**
+ * Create an AttributeAccessor for a class data member of type tuple,
+ * or a lone class get functor or set method.
+ *
+ * \tparam Args \explicit Attribute value types
+ * \tparam T1 \deduced The type of the class data member,
+ *            or the type of the class get functor or set method.
+ * \param a1 The address of the data member,
+ *           or the get or set method.
+ * \return the AttributeAccessor
+ */
+template <class... Args, class T1>
+Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1);
+
+/**
+ * Create an AttributeAccessor using a pair of get functor
+ * and set methods from a class.
+ *
+ * \tparam Args \explicit Attribute value types
+ * \tparam T1 \deduced The type of the class data member,
+ *            or the type of the class get functor or set method.
+ * \tparam T2 \deduced The type of the getter class functor method.
+ * \param a2 The address of the class method to set the attribute.
+ * \param a1 The address of the data member, or the get or set method.
+ * \return the AttributeAccessor
+ */
+template <class... Args, class T1, class T2>
+Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1, T2 a2);
+
+
+}   // namespace ns3
+
+/*****************************************************************************
+ * Implementation below
+ *****************************************************************************/
+
+namespace ns3 {
+
+template <class... Args>
+TupleValue<Args...>::TupleValue ()
+  : m_value (std::make_tuple (Args ()...))
+{
+}
+
+template <class... Args>
+TupleValue<Args...>::TupleValue (const result_type &value)
+{
+  Set (value);
+}
+
+template <class... Args>
+Ptr<AttributeValue>
+TupleValue<Args...>::Copy (void) const
+{
+  return Create <TupleValue <Args...>> (Get ());
+}
+
+template <class... Args>
+template <std::size_t... Is>
+bool
+TupleValue<Args...>::SetValueImpl (std::index_sequence<Is...>, const std::vector<Ptr<AttributeValue>>& values)
+{
+  auto valueTuple = std::make_tuple (DynamicCast<Args> (values[Is])...);
+
+  bool ok = ((std::get<Is> (valueTuple) != nullptr) && ...);
+
+  if (ok)
+    {
+      m_value = std::make_tuple (Args (*std::get<Is> (valueTuple))...);
+    }
+  return ok;
+}
+
+template <class... Args>
+bool
+TupleValue<Args...>::DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker)
+{
+  auto tupleChecker = DynamicCast<const TupleChecker> (checker);
+  if (tupleChecker == nullptr)
+    {
+      return false;
+    }
+
+  auto count = tupleChecker->GetCheckers ().size ();
+  if (count != sizeof...(Args))
+    {
+      return false;
+    }
+
+  if (value.empty () || value.front () != '{' || value.back () != '}')
+    {
+      return false;
+    }
+
+  value.erase (value.begin ());
+  value.pop_back ();
+  std::replace (value.data (), value.data () + value.size (), ',', ' ');
+
+  std::istringstream iss (value);
+  std::vector<Ptr<AttributeValue>> values;
+  std::size_t i = 0;
+
+  while (iss >> value)
+    {
+      if (i >= count)
+        {
+          return false;
+        }
+      values.push_back (tupleChecker->GetCheckers ().at (i++)->CreateValidValue (StringValue (value)));
+      if (values.back () == nullptr)
+        {
+          return false;
+        }
+    }
+
+  if (i != count)
+    {
+      return false;
+    }
+
+  return SetValueImpl (std::index_sequence_for<Args...>{}, values);
+}
+
+template <class... Args>
+std::string
+TupleValue<Args...>::SerializeToString (Ptr<const AttributeChecker> checker) const
+{
+  std::ostringstream oss;
+  oss << "{" << Get () << "}";
+  return oss.str ();
+}
+
+template <class... Args>
+typename TupleValue<Args...>::result_type
+TupleValue<Args...>::Get (void) const
+{
+  return std::apply ([](Args... values)
+                     {
+                       return std::make_tuple (values.Get ()...);
+                     },
+                     m_value);
+}
+
+template <class... Args>
+void
+TupleValue<Args...>::Set (const typename TupleValue<Args...>::result_type &value)
+{
+  m_value = std::apply ([](auto&&... args)
+                        {
+                          return std::make_tuple (Args (args)...);
+                        },
+                        value);
+}
+
+template <class... Args>
+typename TupleValue<Args...>::value_type
+TupleValue<Args...>::GetValue (void) const
+{
+  return m_value;
+}
+
+template <class... Args>
+template <typename T>
+bool
+TupleValue<Args...>::GetAccessor (T &value) const
+{
+  value = T (Get ());
+  return true;
+}
+
+
+
+
+// This internal class defines templated TupleChecker class that is instantiated
+// in MakeTupleChecker. The non-templated base ns3::TupleChecker is returned in that
+// function. This is the same pattern as ObjectPtrContainer.
+namespace internal {
+
+/**
+ * Internal checker class templated to each AttributeChecker
+ * for each entry in the tuple.
+ */
+template <class... Args>
+class TupleChecker : public ns3::TupleChecker
+{
+public:
+  /**
+   * Constructor.
+   * \tparam Ts \deduced the type of the attribute checkers
+   * \param checkers the attribute checkers for individual elements of the tuple
+   */
+  template <class... Ts>
+  TupleChecker (Ts... checkers)
+    : m_checkers {checkers...}
+  {
+  }
+  const std::vector<Ptr<const AttributeChecker>>& GetCheckers (void) const override
+  {
+    return m_checkers;
+  }
+  bool Check (const AttributeValue &value) const override
+  {
+    const TupleValue<Args...>* v = dynamic_cast<const TupleValue<Args...>*> (&value);
+    if (v == nullptr)
+      {
+        return false;
+      }
+    return std::apply ([this](Args... values)
+                       {
+                         std::size_t n{0};
+                         return (m_checkers[n++]->Check (values) && ...);
+                       },
+                       v->GetValue ());
+  }
+  std::string GetValueTypeName (void) const override
+  {
+    return "ns3::TupleValue";
+  }
+  bool HasUnderlyingTypeInformation (void) const override
+  {
+    return false;
+  }
+  std::string GetUnderlyingTypeInformation (void) const override
+  {
+    return "";
+  }
+  Ptr<AttributeValue> Create (void) const override
+  {
+    return ns3::Create<TupleValue<Args...>> ();
+  }
+  bool Copy (const AttributeValue &source, AttributeValue &destination) const override
+  {
+    const TupleValue<Args...> *src = dynamic_cast<const TupleValue<Args...> *> (&source);
+    TupleValue<Args...> *dst = dynamic_cast<TupleValue<Args...> *> (&destination);
+    if (src == 0 || dst == 0)
+      {
+        return false;
+      }
+    *dst = *src;
+    return true;
+  }
+
+private:
+  std::vector<Ptr<const AttributeChecker>> m_checkers;    //!< attribute checkers
+};
+
+/**
+ * Helper class defining static methods for MakeTupleChecker and MakeTupleAccessor
+ * that are called when user specifies the list of AttributeValue types included
+ * in a TupleValue type.
+ */
+template <class... Args>
+struct TupleHelper
+{
+  /**
+   * \copydoc ns3::MakeTupleChecker
+   */
+  template <class... Ts>
+  static Ptr<const AttributeChecker> MakeTupleChecker (Ts... checkers)
+    {
+      return Create <internal::TupleChecker<Args...>> (checkers...);
+    }
+  /**
+   * \copydoc ns3::MakeTupleAccessor(T1)
+   */
+  template <class T1>
+  static Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1)
+  {
+    return MakeAccessorHelper<TupleValue<Args...>> (a1);
+  }
+  /**
+   * \copydoc ns3::MakeTupleAccessor(T1,T2)
+   */
+  template <class T1, class T2>
+  static Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1, T2 a2)
+  {
+    return MakeAccessorHelper<TupleValue<Args...>> (a1, a2);
+  }
+};
+
+/**
+ * Helper class defining static methods for MakeTupleValue, MakeTupleChecker and
+ * MakeTupleAccessor that are called when user provides a std::tuple of the
+ * AttributeValue types included in a TupleValue type.
+ * This struct is a partial specialization of struct TupleHelper.
+ */
+template <class... Args>
+struct TupleHelper<std::tuple<Args...>>
+{
+  /**
+   * \copydoc ns3::MakeTupleValue
+   */
+  static TupleValue<Args...> MakeTupleValue (const typename TupleValue<Args...>::result_type& t)
+    {
+      return TupleValue<Args...> (t);
+    }
+  /**
+   * \copydoc ns3::MakeTupleChecker
+   */
+  template <class... Ts>
+  static Ptr<const AttributeChecker> MakeTupleChecker (Ts... checkers)
+    {
+      return Create <internal::TupleChecker<Args...>> (checkers...);
+    }
+  /**
+   * \copydoc ns3::MakeTupleAccessor(T1)
+   */
+  template <class T1>
+  static Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1)
+  {
+    return MakeAccessorHelper<TupleValue<Args...>> (a1);
+  }
+  /**
+   * \copydoc ns3::MakeTupleAccessor(T1,T2)
+   */
+  template <class T1, class T2>
+  static Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1, T2 a2)
+  {
+    return MakeAccessorHelper<TupleValue<Args...>> (a1, a2);
+  }
+};
+
+} // namespace internal
+
+
+
+template <class T1, class T2>
+auto MakeTupleValue (T2 t)
+{
+  return internal::TupleHelper<T1>::MakeTupleValue (t);
+}
+
+template <class... Args, class... Ts>
+Ptr<const AttributeChecker> MakeTupleChecker (Ts... checkers)
+{
+  return  internal::TupleHelper<Args...>::template MakeTupleChecker<Ts...> (checkers...);
+}
+
+template <class... Args, class T1>
+Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1)
+{
+  return internal::TupleHelper<Args...>::template MakeTupleAccessor<T1> (a1);
+}
+
+template <class... Args, class T1, class T2>
+Ptr<const AttributeAccessor> MakeTupleAccessor (T1 a1, T2 a2)
+{
+  return internal::TupleHelper<Args...>::template MakeTupleAccessor<T1, T2> (a1, a2);
+}
+
+
+
+} // namespace ns3
+
+#endif // TUPLE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/type-id.cc ns-3.36/src/core/model/type-id.cc
--- ns-3.35/src/core/model/type-id.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/type-id.cc	2022-04-30 18:23:57.802733200 -0700
@@ -242,7 +242,6 @@
    *             "ns3::" namespace qualifier.
    * \param [in] supportLevel The support/deprecation status for this attribute.
    * \param [in] supportMsg Upgrade hint if this attribute is no longer supported.
-   * \returns This TypeId instance.
    */
   void AddTraceSource (uint16_t uid,
                        std::string name,
@@ -811,7 +810,7 @@
  *         The TypeId class
  *********************************************************************/
 
-TypeId::TypeId (const char *name)
+TypeId::TypeId (const std::string &name)
 {
   NS_LOG_FUNCTION (this << name);
   uint16_t uid = IidManager::Get ()->AllocateUid (name);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/type-id.h ns-3.36/src/core/model/type-id.h
--- ns-3.35/src/core/model/type-id.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/type-id.h	2022-04-30 18:23:57.802733200 -0700
@@ -176,7 +176,7 @@
    * No two instances can share the same name. The name is expected to be
    * the full c++ typename of associated c++ object.
    */
-  explicit TypeId (const char * name);
+  explicit TypeId (const std::string &name);
 
   /**
    * Get the parent of this TypeId.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/type-name.h ns-3.36/src/core/model/type-name.h
--- ns-3.35/src/core/model/type-name.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/type-name.h	2022-04-30 18:23:57.802733200 -0700
@@ -50,17 +50,19 @@
  * \returns The numeric type name as a string.
  * @{
  */
-template <> std::string TypeNameGet< int8_t  > (void);
-template <> std::string TypeNameGet< int16_t > (void);
-template <> std::string TypeNameGet< int32_t > (void);
-template <> std::string TypeNameGet< int64_t > (void);
-template <> std::string TypeNameGet< uint8_t > (void);
-template <> std::string TypeNameGet< uint16_t> (void);
-template <> std::string TypeNameGet< uint32_t> (void);
-template <> std::string TypeNameGet< uint64_t> (void);
-template <> std::string TypeNameGet< float   > (void);
-template <> std::string TypeNameGet< double  > (void);
-/**@}*/
+// *NS_CHECK_STYLE_OFF*
+template <> inline std::string TypeNameGet< int8_t  > (void) { return "int8_t"  ; };
+template <> inline std::string TypeNameGet< int16_t > (void) { return "int16_t" ; };
+template <> inline std::string TypeNameGet< int32_t > (void) { return "int32_t" ; };
+template <> inline std::string TypeNameGet< int64_t > (void) { return "int64_t" ; };
+template <> inline std::string TypeNameGet< uint8_t > (void) { return "uint8_t" ; };
+template <> inline std::string TypeNameGet< uint16_t> (void) { return "uint16_t"; };
+template <> inline std::string TypeNameGet< uint32_t> (void) { return "uint32_t"; };
+template <> inline std::string TypeNameGet< uint64_t> (void) { return "uint64_t"; };
+template <> inline std::string TypeNameGet< float   > (void) { return "float"   ; };
+template <> inline std::string TypeNameGet< double  > (void) { return "double"  ; };
+// *NS_CHECK_STYLE_ON*
+/** @} */
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/unused.h ns-3.36/src/core/model/unused.h
--- ns-3.35/src/core/model/unused.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/unused.h	2022-04-30 18:23:57.802733200 -0700
@@ -21,33 +21,59 @@
 #ifndef UNUSED_H
 #define UNUSED_H
 
+#include "ns3/deprecated.h"
+
 /**
  * \file
  * \ingroup core
  * NS_UNUSED and NS_UNUSED_GLOBAL macro definitions.
  */
 
+
 /**
  * \ingroup core
  * \def NS_UNUSED()
  * Mark a local variable as unused.
+ *
+ * \deprecated Please use `[[maybe_unused]]` directly. This macro is being
+ * kept temporarily to support older code.
  */
+
+// We can't use NS_DEPRECATED_3_36 here because NS_UNUSED
+// is used as a statement following a declaration:
+//   int x;
+//   NS_UNUSED (x);
+// NS_DEPRECATED needs to be applied to the declaration
+//   NS_DEPRECATED_3_36 ("use double instead") int x;
+// Instead we resort to a pragma
+
 #ifndef NS_UNUSED
-# define NS_UNUSED(x) ((void)(x))
+# define NS_UNUSED(x) \
+  _Pragma ("GCC warning \"NS_UNUSED is deprecated, use [[maybe_unused]] directly\"") \
+  ((void)(x))
 #endif
 
 /**
  * \ingroup core
  * \def NS_UNUSED_GLOBAL()
  * Mark a variable at file scope as unused.
+ *
+ * \deprecated Please use `[[maybe_unused]]` directly. This macro is being
+ * kept temporarily to support older code.
  */
 #ifndef NS_UNUSED_GLOBAL
 #if defined(__GNUC__)
-# define NS_UNUSED_GLOBAL(x) x __attribute__((unused))
+# define NS_UNUSED_GLOBAL(x) \
+  NS_DEPRECATED_3_36 ("NS_UNUSED_GLOBAL is deprecated, use [[maybe_unused]] directly") \
+  [[maybe_unused]] x
 #elif defined(__LCLINT__)
-# define NS_UNUSED_GLOBAL(x) /*@unused@*/ x
+# define NS_UNUSED_GLOBAL(x) \
+  NS_DEPRECATED_3_36 ("NS_UNUSED_GLOBAL is deprecated, use [[maybe_unused]] directly") \
+  /*@unused@*/ x
 #else
-# define NS_UNUSED_GLOBAL(x) x
+# define NS_UNUSED_GLOBAL(x) \
+  NS_DEPRECATED_3_36 ("NS_UNUSED_GLOBAL is deprecated, use [[maybe_unused]] directly") \
+  x
 #endif
 #endif
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/version-defines.h.in ns-3.36/src/core/model/version-defines.h.in
--- ns-3.35/src/core/model/version-defines.h.in	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/version-defines.h.in	2022-04-30 18:23:57.802733200 -0700
@@ -134,7 +134,7 @@
 
 /**
  * Indicates the build profile that was specified by the --build-profile option
- * of "waf configure"
+ * of "ns3 configure"
  *
  * Type: string literal
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/version.h ns-3.36/src/core/model/version.h
--- ns-3.35/src/core/model/version.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/version.h	2022-04-30 18:23:57.802733200 -0700
@@ -94,7 +94,7 @@
  * | TagDistance        | 1        |       |
  * | CommitHash         | g6ad7f05 | g at front of hash indicates a git hash |
  * | DirtyWorkingTree   | Variable | Depends on status of git working and stage areas |
- * | BuildProfile       | Variable | Depends on the value of --build-profile option of waf configure |
+ * | BuildProfile       | Variable | Depends on the value of --build-profile option of ns3 configure |
  */
 class Version
 {
@@ -207,7 +207,7 @@
   /**
    * Indicates the type of build that was performed (debug/release/optimized).
    *
-   * This information is set by the --build-profile option of waf configure
+   * This information is set by the --build-profile option of ns3 configure
    *
    * \return String containing the type of build
    */
